"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _monitor = _interopRequireDefault(require("./monitor"));

var _ipSub = _interopRequireDefault(require("ip-sub"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var MonitorVisibility = /*#__PURE__*/function (_Monitor) {
  _inherits(MonitorVisibility, _Monitor);

  var _super = _createSuper(MonitorVisibility);

  function MonitorVisibility(name, channel, params, env, input) {
    var _this;

    _classCallCheck(this, MonitorVisibility);

    _this = _super.call(this, name, channel, params, env, input);

    _defineProperty(_assertThisInitialized(_this), "updateMonitoredResources", function () {
      _this.monitored = _this.input.getMonitoredPrefixes();
    });

    _defineProperty(_assertThisInitialized(_this), "filter", function (message) {
      return message.type === 'withdrawal';
    });

    _defineProperty(_assertThisInitialized(_this), "squashAlerts", function (alerts) {
      var peers = _toConsumableArray(new Set(alerts.map(function (alert) {
        return alert.matchedMessage.peer;
      }))).length;

      if (peers >= _this.thresholdMinPeers) {
        return peers === 1 ? "The prefix ".concat(alerts[0].matchedMessage.prefix, " (").concat(alerts[0].matchedRule.description, ") it's no longer visible (withdrawn) from the peer ").concat(alerts[0].matchedMessage.peer) : "The prefix ".concat(alerts[0].matchedMessage.prefix, " (").concat(alerts[0].matchedRule.description, ") has been withdrawn. It is no longer visible from ").concat(peers, " peers");
      } else {
        return false;
      }
    });

    _defineProperty(_assertThisInitialized(_this), "monitor", function (message) {
      return new Promise(function (resolve, reject) {
        var messagePrefix = message.prefix;

        var matchedRule = _this.getMoreSpecificMatch(messagePrefix, false);

        if (matchedRule && !matchedRule.ignore && _ipSub["default"]._isEqualPrefix(matchedRule.prefix, messagePrefix)) {
          var key = matchedRule.prefix;

          _this.publishAlert(key, matchedRule.asn.getId(), matchedRule, message, {});
        }

        resolve(true);
      });
    });

    _this.thresholdMinPeers = params && params.thresholdMinPeers != null ? params.thresholdMinPeers : 40;

    if (params.threshold) {
      _this.logger.log({
        level: 'error',
        message: "The parameter threshold has been replaced by thresholdMinPeers and it will be soon deprecated."
      });

      _this.thresholdMinPeers = params.threshold;
    }

    _this.updateMonitoredResources();

    return _this;
  }

  return MonitorVisibility;
}(_monitor["default"]);

exports["default"] = MonitorVisibility;